#!/usr/local/bin/perl
$version="1.1";
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
#                                                                            #
#   VERSION FRANCAISE : Sbastien Joncheray, http://www.perl-gratuit.com     #
#   Renomm wwwboard-vf.pl                                                   #
#                                                                            #
#   POUR INSTALLER CE FORUM DE DISCUSSION, VOYEZ LE FICHIER LISEZMOI.TXT !   #
#                                                                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# Definition des Variables

$basedir = "/path/to/wwwboard-vf";
$baseurl = "http://your.host.xxx/wwwboard-vf";
$cgi_url = "http://your.host.xx/cgi-bin/wwwboard-vf.pl";
 
$mesgdir = "messages";
$datafile = "data.txt";
$mesgfile = "wwwboard-vf.html";
$faqfile = "faq.html";
$ext = "html";
$title = "Forum WWWBoard-vf";
 
# OPTION AJOUTEE DANS LA VERSION FRANCAISE :
# Vous pouvez prciser ici des paramtres de couleurs pour les pages HTML.
# ceci sera ajout dans le tag <BODY> des fichiers HTML.
# Vous pouvez ainsi prciser :
# - une couleur de fond en mettant : $body_opt='BGCOLOR="#C0C0C0"';  (gris)
# - une image de fond en mettant   : $body_opt='BACKGROUND="http://www.votresite.com/votre/image/de/fond.gif"';
# - une couleur de texte en mettant: $body_opt='text="#000080"'; (bleu fonc)
# - une couleur de lien en mettant : $body_opt='link="#008000"'; (vert)
# - une couleur de lien visit en mettant: $body_opt='vlink="#FF0000"'; (rouge)
# Mettez les valeurs de votre choix, vous pouvez combiner tout cela, en sparant
#  les lments par un espace, exemple :
# $body_opt='bgcolor="#C0C0C0" text="#000080" link="#008000" vlink="#FF0000" alink="#FF0000"';
 
$body_opt='';
 
# Done
 
###########################################################################
# Options de Configuration
 
$show_faq = 1;		# 1 - OUI; 0 = NON
$allow_html = 1;	# 1 = OUI; 0 = NON
$quote_text = 1;	# 1 = OUI; 0 = NON
$subject_line = 0;	# 0 = Quote Subject Editable; 1 = Quote Subject 
 			#   UnEditable; 2 = Don't Quote Subject, Editable.
$use_time = 1;		# 1 = OUI; 0 = NON

# Done
###########################################################################
 
# Rcupre le numro d'article
&get_number;

# Rcupre les donnes du formulaire
&parse_form;

# Traitement des donnes du formulaire
&get_variables;

# Ouvre une nouveau fichier et ecrit les informations dedans
&new_file;

# Ouvre la page principale de WWWBoard-vf t ajute un lien
&main_page;

# Ajoute des liens dans les pages individuelles
if ($num_followups >= 1) {
   &thread_pages;
}

# Retourne la page HTML  l'utilisateur
&return_html;

# Incremente le nombre d'articles
&increment_num;

############ SOUS-PROGRAMMES : ############################################
###########################################################################
# MESSAGES D'ERREUR AJOUTES (POUR LA VERSION FRANCAISE SEULEMENT), car ce #
# script en manque particulirement en cas de mauvaise configuration.     #
###########################################################################
sub erreur {
local ($tip)=@_;
  print "Content-type: text/html\n\n";

  print <<_EOLERREUR_;
  <html><head><title>ERREUR</title></head><body>
  <div align="center"><center> &nbsp; <br> &nbsp; <br>
  <table border="0" width="70%">
    <tr>
     <td width="100%" bgcolor="#C0C0C0"><p align="center"><strong><font face="Arial">ERREUR :</font></strong></td>
    </tr>  <tr>
     <td width="100%" bgcolor="#EBCE76"><p><font face="Arial" size="2"> &nbsp; <br>$tip<br> &nbsp; </font></p>
   </tr>
   <tr>
    <td width="100%" bgcolor="#C0C0C0"><p align="center"><strong><font face="Arial" size="1">WWWBoard-vf v$version. Script
    CGI Perl gratuit ralis par Sbastien Joncheray, disponible sur <a
    href="http://www.perl-gratuit.com">perl-gratuit.com</a> </font></strong></td>
   </tr>
  </table>
  </center></div>
  </body></html>

_EOLERREUR_

  exit(0);
}
###########################################################################
############################
# sous-programme rcuprant le numro d'article

sub get_number {
   open(NUMBER,"$basedir/$datafile") || (&erreur("Impossible de lire le fichier $basedir/$datafile.<br>"));
   $num = <NUMBER>;
   close(NUMBER);
   if ($num == 99999)  {
      $num = "1";
   }
   else {
      $num++;
   }
}

#######################
# sous-programme rcuprant les donnes du formulaire

sub parse_form {

   # Lit l'entre standard
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Spare les paires nom/valeur
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      # Dcodage
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;

      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
      }
      else {
         unless ($name eq 'body') {
	    $value =~ s/<([^>]|\n)*>//g;
         }
      }

      $FORM{$name} = $value;
   }

}

###############
# Traitement des donnes du formulaire

sub get_variables {

   if ($FORM{'followup'}) {
      $followup = "1";
      @followup_num = split(/,/,$FORM{'followup'});
      $num_followups = @followups = @followup_num;
      $last_message = pop(@followups);
      $origdate = "$FORM{'origdate'}";
      $origname = "$FORM{'origname'}";
      $origsubject = "$FORM{'origsubject'}";
   }
   else {
      $followup = "0";
   }

   if ($FORM{'name'}) {
      $name = "$FORM{'name'}";
      $name =~ s/"//g;
      $name =~ s/<//g;
      $name =~ s/>//g;
      $name =~ s/\&//g;
   }
   else {
      &error(no_name);
   }

   if ($FORM{'email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'email'}";
   }

   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
   }
   else {
      &error(no_subject);
   }

   if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'}) {
      $message_url = "$FORM{'url'}";
      $message_url_title = "$FORM{'url_title'}";
   }

   if ($FORM{'img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$FORM{'img'}";
   }

   if ($FORM{'body'}) {
      $body = "$FORM{'body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;
      $body =~ s/\n/<br>/g;

      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
      $body =~ s/&quot;/"/g;
   }
   else {
      &error(no_body);
   }

   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("Janvier","Fvrier","Mars","Avril","Mai","Juin","Juillet","Aout","Septembre","Octobre","Novembre","Decembre");

   $year += 1900;
   $long_date = sprintf("%s %02d, %4d at %02d:%02d:%02d",$months[$mon],$mday,$year,$hour,$min,$sec);
   $year %= 100;
   if ($use_time == 1) {
     $date = sprintf("%02d:%02d:%02d %02d/%02d/%02d",$hour,$min,$sec,$month,$mday,$year);
   } else {
     $date = sprintf("%02d/%02d/%02d",$month,$mday,$year);
   }
}      

#####################
# sous-programme de cration d'un nouveau fichier-article

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || (&erreur("Impossible de crer le fichier $basedir/$mesgdir/$num\.$ext.! <br>
                                                             Vrifiez que le rpertoire $basedir/$mesgdir/ existe, avecles permissions d\criture pour tous (chmod 777). $!"));
   print NEWFILE "<html>\n";
   print NEWFILE "  <head>\n";
   print NEWFILE "    <title>$subject</title>\n";
   print NEWFILE "  </head>\n";
   print NEWFILE "  <body $body_opt>\n";
   print NEWFILE "    <center>\n";
   print NEWFILE "      <h1>$subject</h1>\n";
   print NEWFILE "    </center>\n";
   print NEWFILE "<hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print NEWFILE "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ] [ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
      print NEWFILE "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   print NEWFILE "<hr size=7 width=75%><p>\n";

   print NEWFILE "Ecrit par ";

   if ($email) {
      print NEWFILE "<a href=\"mailto:$email\">$name</a> le $long_date:<p>\n";
   }
   else {
      print NEWFILE "$name le $long_date:<p>\n";
   }

   if ($followup == 1) {
      print NEWFILE "En rponse : <a href=\"$last_message\.$ext\">$origsubject</a> crit par ";

      if ($origemail) {
         print NEWFILE "<a href=\"$origemail\">$origname</a> le $origdate:<p>\n";
      }
      else {
         print NEWFILE "$origname le $origdate:<p>\n";
      }
   }

   if ($message_img) {
      print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
   }
   print NEWFILE "$body\n";
   print NEWFILE "<br>\n";
   if ($message_url) {
      print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<br><hr size=7 width=75%><p>\n";
   print NEWFILE "<a name=\"followups\">Rponses:</a><br>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "<br><hr size=7 width=75%><p>\n";
   print NEWFILE "<a name=\"postfp\">Rpondre</a><p>\n";
   print NEWFILE "<form method=POST action=\"$cgi_url\">\n";
   print NEWFILE "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
      foreach $followup_num (@followup_num) {
         print NEWFILE "$followup_num,";
      }
   }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"origname\" value=\"$name\">\n";
   if ($email) {
      print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print NEWFILE "Name: <input type=text name=\"name\" size=50><br>\n";
   print NEWFILE "E-Mail: <input type=text name=\"email\" size=50><p>\n";
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"$subject\">\n";
         print NEWFILE "Objet: <b>$subject</b><p>\n";
      }
      else {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"Re: $subject\">\n";
         print NEWFILE "Objet: <b>Re: $subject</b><p>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print NEWFILE "Objet: <input type=text name=\"subject\" size=50><p>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print NEWFILE "Objet: <input type=text name=\"subject\"value=\"$subject\" size=50><p>\n";
      }
      else {
         print NEWFILE "Objet: <input type=text name=\"subject\" value=\"Re: $subject\" size=50><p>\n";
      }
   }
   print NEWFILE "Commentaites:<br>\n";
   print NEWFILE "<textarea name=\"body\" COLS=50 ROWS=10>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print NEWFILE ": $line_of_body\n";
         }
         print NEWFILE "\n";
      }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p>\n";
   print NEWFILE "URL de Lien Optionnel: <input type=text name=\"url\" size=50><br>\n";
   print NEWFILE "Titre du Lien: <input type=text name=\"url_title\" size=48><br>\n";
   print NEWFILE "URL d'une Image Optionnelle: <input type=text name=\"img\" size=49><p>\n";
   print NEWFILE "<input type=submit value=\"Envoyer la Rponse\"> <input type=reset>\n";
   print NEWFILE "<p><hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print NEWFILE "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ] [ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
      print NEWFILE "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   print NEWFILE "</body></html>\n";
   close(NEWFILE);
}

###############################
# Sous programme principal

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || (&erreur("Impossible de lire le fichier $basedir/$mesgfile : $!"));
   @main = <MAIN>;
   close(MAIN);

   open(MAIN,">$basedir/$mesgfile") || (&erreur("Impossible de rcrire le fichier $basedir/$mesgfile:$! <br><br> Vrifiez que ce fichiers possde les droits d\'criture (chmod 777)"));
   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> <i>$date</i>\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   close(MAIN);
}

############################################
# Ajout de lien de rponses pour pages individuelles
sub thread_pages {

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> <b>$name</b> <i>$date</i>\n";
            print FOLLOWUP "(<!--responses: $num-->0)\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      close(FOLLOWUP);
   }
}

sub return_html {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Message Ajout: $subject</title></head>\n";
   print "<body $body_opt><center><h1>Message Ajout: $subject</h1></center>\n";
   print "Les informations suivantes ont t ajoute au Forum:<p><hr size=7 width=75%><p>\n";
   print "<b>Nom:</b> $name<br>\n";
   print "<b>E-Mail:</b> $email<br>\n";
   print "<b>Objet:</b> $subject<br>\n";
   print "<b>Message:</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
      print "<b>Lien:</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
      print "<b>Image:</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>Ajout le:</b> $date<p>\n";
   print "<hr size=7 width=75%>\n";
   print "<center>[ <a href=\"$baseurl/$mesgdir/$num\.$ext\">Aller  votre message</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   print "</body></html>\n";
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || (&erreur("Impossible de rcrire le fichier $basedir/$datafile:$! <br><br>Vrifiez que ce ficher possde les droits d\'criture (chmod 777)"));
   print NUM "$num";
   close(NUM);
}

sub error {
   $error = $_[0];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name') {
      print "<html><head><title>$title ERREUR: Nom manquant</title></head>\n";
      print "<body $body_opt><center><h1>ERREUR: Non manquant</h1></center>\n";
      print "Vous n\'avez pas indiqu votre nom.  Corrigez cela ci-dessous et revalidez.  Les champs ncessaires sont: Nom, Objet et Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_subject') {
      print "<html><head><title>$title ERREUR: Objet manquant</title></head>\n";
      print "<body $body_opt><center><h1>ERREUR: Objet manquant</h1></center>\n";
      print "Vous n\'avez pas indiqu l\'Objet du message.  Corrigez cela ci-dessous et revalidez.  Les champs ncessaires sont: Nom, Objet et Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_body') {
      print "<html><head><title>$title ERREUR: Message manquant</title></head>\n";
      print "<body $body_opt><center><h1>ERREUR: Message manquant</h1></center>\n";
      print "Vous n\'avez pas indiqu de Message.  Corrigez cela ci-dessous et revalidez.  Les champs ncessaires sont: Nom, Objet et Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   else {
      print "ERREUR!  Non connue.\n";
   }
   exit;
}

sub rest_of_form {

   print "<form method=POST action=\"$cgi_url\">\n";

   if ($followup == 1) {
      print "<input type=hidden name=\"origsubject\" value=\"$FORM{'origsubject'}\">\n";
      print "<input type=hidden name=\"origname\" value=\"$FORM{'origname'}\">\n";
      print "<input type=hidden name=\"origemail\" value=\"$FORM{'origemail'}\">\n";
      print "<input type=hidden name=\"origdate\" value=\"$FORM{'origdate'}\">\n";
      print "<input type=hidden name=\"followup\" value=\"$FORM{'followup'}\">\n";
   }
   print "Nom: <input type=text name=\"name\" value=\"$FORM{'name'}\" size=50><br>\n";
   print "E-Mail: <input type=text name=\"email\" value=\"$FORM{'email'}\" size=50><p>\n";
   if ($subject_line == 1) {
      print "<input type=hidden name=\"subject\" value=\"$FORM{'subject'}\">\n";
      print "Objet: <b>$FORM{'subject'}</b><p>\n";
   } 
   else {
      print "Objet: <input type=text name=\"subject\" value=\"$FORM{'subject'}\" size=50><p>\n";
   }
   print "Message:<br>\n";
   print "<textarea COLS=50 ROWS=10 name=\"body\">\n";
   $FORM{'body'} =~ s/</&lt;/g;
   $FORM{'body'} =~ s/>/&gt;/g;
   $FORM{'body'} =~ s/"/&quot;/g;
   print "$FORM{'body'}\n";
   print "</textarea><p>\n";
   print "URL de Lien Optionnel: <input type=text name=\"url\" value=\"$FORM{'url'}\" size=45><br>\n";
   print "Titre du Lien: <input type=text name=\"url_title\" value=\"$FORM{'url_title'}\" size=50><br>\n";
   print "URL d'une Image Optionnelle: <input type=text name=\"img\" value=\"$FORM{'img'}\" size=45><p>\n";
   print "<input type=submit value=\"Post Message\"> <input type=reset>\n";
   print "</form>\n";
   print "<br><hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ] [ <a href=\"$baseurl/$faqfile\">FAQ</a> ]</center>\n";
   }
   else {
      print "<center>[ <a href=\"#followups\">Rponses</a> ] [ <a href=\"#postfp\">Rpondre</a> ] [ <a href=\"$baseurl/$mesgfile\">$title</a> ]</center>\n";
   }
   print "</body></html>\n";
}
